﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
  using System;
  using System.Threading;

  public abstract class StatefullExpression<T> : Expression {

    protected T State { get; set; }

    private readonly Lazy<int> hashCode;

    protected StatefullExpression(T state, string stringRepresentation) : base(stringRepresentation) {
      this.State = state;
      this.hashCode = new Lazy<int>(this.CalcHashCode, LazyThreadSafetyMode.ExecutionAndPublication);
    }

    protected virtual int CalcHashCode() {
      return this.State.GetHashCode();
    }

    public override bool Equals(object obj) {
      return obj != null && (this == obj || (this.GetType() == obj.GetType() && this.GetHashCode() == obj.GetHashCode()));
    }

    public override int GetHashCode() {
      return hashCode.Value;
    }
  }
}